VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ServiceProviders"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"ServiceProvider"
Attribute VB_Ext_KEY = "Member0" ,"ServiceProvider"
'##CD ServiceProviders class is a collection of ServiceProvider objects.
Attribute VB_HelpID=2071
Attribute VB_Description="ServiceProviders class is a collection of ServiceProvider objects."
Option Explicit

'local variable to hold collection
Private mCol As Collection
Private mvarParent As MultiEngine
Friend Sub Clear()
Attribute Clear.VB_HelpID = 2074
    Do Until Count = 0
        Call Remove(1)
    Loop
End Sub

Friend Function Add(ByVal Key As String, ByVal ConnName As String, ByVal ConnGuid As String, ConnAddress As DirectPlayAddress, _
                                        ByVal ConnFlags As Long, Optional ByVal sKey As String) As ServiceProvider
Attribute Add.VB_HelpID = 2075
    Dim objNewMember As ServiceProvider

    Set objNewMember = New ServiceProvider

    'set the properties passed into the method
    With objNewMember
        .Key = Key
        Call .SetInformation(ConnAddress, ConnFlags, ConnGuid, ConnName)
        Set .Parent = Me
    End With

    If Len(sKey) = 0 Then
        Call mCol.Add(objNewMember)
    Else
        Call mCol.Add(objNewMember, sKey)
    End If

    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing
End Function

Public Property Get Item(vntIndexKey As Variant) As ServiceProvider
Attribute Item.VB_HelpID = 2076
Attribute Item.VB_UserMemId = 0
    Set Item = mCol(vntIndexKey)
End Property

Public Property Get Count() As Long
Attribute Count.VB_HelpID = 2077
Attribute Count.VB_Description = "Returns the total number of ServiceProvider object located within the collection."
'##BD Returns the total number of ServiceProvider object located within the collection.
    Count = mCol.Count
End Property

Friend Sub Remove(vntIndexKey As Variant)
Attribute Remove.VB_HelpID = 2078
    Call mCol.Remove(vntIndexKey)
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_HelpID = 2079
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = mCol.[_NewEnum]
End Property

Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
End Sub

Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
    Set mvarParent = Nothing
End Sub


Public Property Get Parent() As MultiEngine
Attribute Parent.VB_HelpID = 2082
Attribute Parent.VB_Description = "Returns or sets the object directly above this object.  "
'##BD Returns or sets the object directly above this object.
    Set Parent = mvarParent
End Property

Public Property Set Parent(ByVal vData As MultiEngine)
    Set mvarParent = vData
End Property
