VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Spectator"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Option Explicit

Public Key As String

'local variable(s) to hold property value(s)
Private mvarDPID As Long
Private mvarFlags As Long
Private mvarLongName As String
Private mvarShortName As String
Private mvarType_ As mePlayerType
Private mvarAccountID As String
Private mvarPlayerCaps As DPCAPS
Private mvarPlayerData As String
Private mvarPlayerCapsGuaranteed As DPCAPS
Private mvarTypeFlags As CONST_DPPLAYERFLAGS
Public Property Get Type_() As mePlayerType
    Type_ = mvarType_
End Property

Public Property Get ShortName() As String
    ShortName = mvarShortName
End Property

Public Property Get LongName() As String
Attribute LongName.VB_UserMemId = 0
    LongName = mvarLongName
End Property

Public Property Get flags() As Long
    flags = mvarFlags
End Property

Public Property Get DPID() As Long
    DPID = mvarDPID
End Property

Friend Sub SetInformation(ByVal DPID As Long, ByVal flags As Long, ByVal LName As String, ByVal SName As String, ByVal lType As Long)
    mvarType_ = lType
    mvarShortName = SName
    mvarLongName = LName
    mvarFlags = flags
    mvarDPID = DPID
End Sub

Public Property Get Data() As String
    Data = mvarPlayerData
End Property

Public Property Get Capabilities() As DPCAPS
    On Error GoTo Handler
    
    Call MEngine.DirectPlayObject.GetPlayerCaps(DPID, mvarPlayerCaps, DPGETCAPS_DEFAULT)
    Capabilities = mvarPlayerCaps
    Exit Property
    
Handler:
    If Err = DPERR_INVALIDOBJECT Then
        Call MEngine.FireErrorEvent(Err.Number, "The DirectPlay object is invalid.", "ServiceProvider RefreshSessions Function")
    ElseIf Err = DPERR_INVALIDPLAYER Then
        Call MEngine.FireErrorEvent(Err.Number, "The player ID is not recognized as a valid player ID for this game session.", "ServiceProvider RefreshSessions Function")
    ElseIf Err = DPERR_INVALIDPARAMS Then
        Call MEngine.FireErrorEvent(Err.Number, "One or more of the parameters passed to the method are invalid.", "ServiceProvider RefreshSessions Function")
    Else
        Call MEngine.FireErrorEvent(Err.Number, Err.Description, "Session RefreshPlayers Function")
    End If
End Property

Public Property Get CapabilitiesGuaranteed() As DPCAPS
    On Error GoTo Handler
    
    Call MEngine.DirectPlayObject.GetPlayerCaps(DPID, mvarPlayerCapsGuaranteed, DPGETCAPS_GUARANTEED)
    CapabilitiesGuaranteed = mvarPlayerCapsGuaranteed
    Exit Property
    
Handler:
    If Err = DPERR_INVALIDOBJECT Then
        Call MEngine.FireErrorEvent(Err.Number, "The DirectPlay object is invalid.", "ServiceProvider RefreshSessions Function")
    ElseIf Err = DPERR_INVALIDPLAYER Then
        Call MEngine.FireErrorEvent(Err.Number, "The player ID is not recognized as a valid player ID for this game session.", "ServiceProvider RefreshSessions Function")
    ElseIf Err = DPERR_INVALIDPARAMS Then
        Call MEngine.FireErrorEvent(Err.Number, "One or more of the parameters passed to the method are invalid.", "ServiceProvider RefreshSessions Function")
    Else
        Call MEngine.FireErrorEvent(Err.Number, Err.Description, "Session RefreshPlayers Function")
    End If
End Property

Public Property Get TypeFlags() As CONST_DPPLAYERFLAGS
    On Error GoTo Handler
    
    mvarTypeFlags = MEngine.DirectPlayObject.GetPlayerFlags(DPID)
    TypeFlags = mvarTypeFlags
    Exit Property
    
Handler:
    Call MEngine.FireErrorEvent(Err.Number, Err.Description, "Session RefreshPlayers Function")
End Property
Public Property Get AccountID() As String
    AccountID = mvarAccountID
End Property
