VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Spectators"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"Spectator"
Attribute VB_Ext_KEY = "Member0" ,"Player"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable to hold collection
Private mCol As Collection
Friend Sub Clear()
    Do Until Count = 0
        Call Remove(1)
    Loop
End Sub


Friend Function Add(Key As String, Optional sKey As String) As Spectator
    'create a new object
    Dim objNewMember As Spectator
    Set objNewMember = New Spectator

    'set the properties passed into the method
    objNewMember.Key = Key
    If Len(sKey) = 0 Then
        Call mCol.Add(objNewMember)
    Else
        Call mCol.Add(objNewMember, sKey)
    End If

    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing
End Function

Public Property Get Item(vntIndexKey As Variant) As Spectator
Attribute Item.VB_MemberFlags = "200"
    Set Item = mCol(vntIndexKey)
End Property



Public Property Get Count() As Long
    Count = mCol.Count
End Property


Friend Sub Remove(vntIndexKey As Variant)
    Call mCol.Remove(vntIndexKey)
End Sub


Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = mCol.[_NewEnum]
End Property


Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
End Sub


Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub

