VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Files"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"File"
Attribute VB_Ext_KEY = "Member0" ,"File"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'##MODULE_IS_NEW
'##CD Collection of File objects.
Attribute VB_HelpID=2363
Attribute VB_Description="Collection of File objects."
Option Explicit

'local variable to hold collection
Private mCol As Collection
Friend Sub Clear()
    Do Until Count = 0
        Call Remove(1)
    Loop
End Sub


Friend Function Add(ByVal Key As String, ByVal Name_ As String, Optional ByVal sKey As String) As File
    'create a new object
    Dim objNewMember As File
    Set objNewMember = New File

    'set the properties passed into the method
    With objNewMember
        .Key = Key
        .Name_ = Name_
    End With
    
    If Len(sKey) = 0 Then
        Call mCol.Add(objNewMember)
    Else
        Call mCol.Add(objNewMember, sKey)
    End If

    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing
End Function

Public Property Get Item(vntIndexKey As Variant) As File
Attribute Item.VB_HelpID = 2364
    Set Item = mCol(vntIndexKey)
End Property



Public Property Get Count() As Long
Attribute Count.VB_HelpID = 2365
'BD Total number of files in the current folder on the current ftp server.
    Count = mCol.Count
End Property


Friend Sub Remove(vntIndexKey As Variant)
    Call mCol.Remove(vntIndexKey)
End Sub


Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_HelpID = 2366
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = mCol.[_NewEnum]
End Property


Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
End Sub


Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub

