VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "RegisteredApps"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"RegisteredApplication"
Attribute VB_Ext_KEY = "Member0" ,"RegisteredApplication"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'##CD Collection of RegisteredApp objects.
Attribute VB_HelpID=2187
Attribute VB_Description="Collection of RegisteredApp objects."
Option Explicit

'local variable to hold collection
Private mCol As Collection

Friend Function Add(Key As String, Optional sKey As String) As RegisteredApp
Attribute Add.VB_HelpID = 2190
    'create a new object
    Dim objNewMember As RegisteredApp
    Set objNewMember = New RegisteredApp

    'set the properties passed into the method
    objNewMember.Key = Key
    If Len(sKey) = 0 Then
        Call mCol.Add(objNewMember)
    Else
        Call mCol.Add(objNewMember, sKey)
    End If

    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing
End Function

Friend Sub Clear()
Attribute Clear.VB_HelpID = 2191
    Do Until Count = 0
        Call Remove(1)
    Loop
End Sub

Public Property Get Item(vntIndexKey As Variant) As RegisteredApp
Attribute Item.VB_HelpID = 2192
Attribute Item.VB_UserMemId = 0
    Set Item = mCol(vntIndexKey)
End Property



Public Property Get Count() As Long
Attribute Count.VB_HelpID = 2193
Attribute Count.VB_Description = "Total number of RegisteredApp objects within the collection."
'##BD Total number of RegisteredApp objects within the collection.
    Count = mCol.Count
End Property


Friend Sub Remove(vntIndexKey As Variant)
Attribute Remove.VB_HelpID = 2194
    Call mCol.Remove(vntIndexKey)
End Sub


Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_HelpID = 2195
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = mCol.[_NewEnum]
End Property

Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
End Sub


Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub

